mergeObjects(multiscroll, {
	drag : {
		markerImage : null,
		scrollX : 0,
		scrollY : 0,
		
		start : function(evt) {
			multiscroll.startX = evt.clientX;
			multiscroll.startY = evt.clientY;
		
			this.active = true;
			this.done = true;

			this.scrollX = multiscroll.clientFrame.pageXOffset;
			this.scrollY = multiscroll.clientFrame.pageYOffset;

			this.insertMarker(evt);
			window.setCursor(this.cursor);
		},
		stop : function(evt) {
			this.active = false;
			this.removeMarker(evt);
			window.setCursor("default");
		},
		Do : function(evt) { with (multiscroll) {
			window.setCursor(this.cursor);
			var x = (startX - clientX) * this.settings.multiplier;
			var y = (startY - clientY) * this.settings.multiplier;
			x = x>0 ? Math.pow(Math.abs(x), this.settings.exponent) : x<0 ? -Math.pow(Math.abs(x), this.settings.exponent) : 0;
			y = y>0 ? Math.pow(Math.abs(y), this.settings.exponent) : y<0 ? -Math.pow(Math.abs(y), this.settings.exponent) : 0;
			startX = clientX;
			startY = clientY;
			this.scrollX += x;
			this.scrollY += y;
			clientFrame.scrollTo(this.scrollX, this.scrollY);
			if (Math.abs(this.scrollX - clientFrame.pageXOffset) > 10 )
				this.scrollX = clientFrame.pageXOffset;
			if (Math.abs(this.scrollY - clientFrame.pageYOffset) > 10 )
				this.scrollY = clientFrame.pageYOffset;
			// retain sub-pixel movements but protect edges from exponential dragging
		} },
		insertMarker : function(evt) {
			var left = evt.clientX;
			var top = evt.clientY;
			var imageWidth = 30;
			var imageHeight = 30;
		
			// marker
			var el = multiscroll.clientFrameDoc.createElementNS("http://www.w3.org/1999/xhtml", "img");
			el.src = this.image;
		
			el.style.position = "fixed";
			el.style.left = left - imageWidth / 2 + "px";
			el.style.top = top - imageHeight / 2 + "px";
			el.style.width = imageWidth + "px";
			el.style.height = imageHeight + "px";
			el.style.cursor = this.cursor;
		
			multiscroll.clientFrameBody.appendChild(el);
		
			this.markerImage = el;
		},
		removeMarker : function() {
			if (this.markerImage != null)
				this.markerImage.parentNode.removeChild(this.markerImage);
		
			this.markerImage = null;
		}
	}
});