mergeObjects(multiscroll, {
	pan : {
		scaleFactor : null,
		oldScaleFactor : 1,
		docOldLocation : null,
		docMarker : null,
		docBackgroundMarker : null,
		thumbnailMarker : null,
		winMarker : null,
		docMarkerLeft : 0, docMarkerTop : 0, docMarkerWidth : 0, docMarkerHeight : 0,
		winMarkerWidth : 0, winMarkerHeight : 0,
	}
});
multiscroll.pan.winMarkerLeft getter= function() { with (multiscroll) {
			return Math.min(pan.docMarkerLeft + pan.docMarkerWidth - pan.winMarkerWidth, 
					Math.max(pan.docMarkerLeft,
						clientX - pan.winMarkerWidth / 2));
		} };
multiscroll.pan.winMarkerTop getter= function() { with (multiscroll) {
			return Math.min(pan.docMarkerTop + pan.docMarkerHeight - pan.winMarkerHeight, 
					Math.max(pan.docMarkerTop,
						clientY - pan.winMarkerHeight / 2));
		} };
multiscroll.pan.scrollX getter= function() { with (multiscroll.pan) {
			return (winMarkerLeft - docMarkerLeft) / scaleFactor;
		} };
multiscroll.pan.scrollY getter= function() { with (multiscroll.pan) {
			return (winMarkerTop - docMarkerTop) / scaleFactor;
		} };
mergeObjects(multiscroll, {
	pan : {
		start : function(evt) {
			multiscroll.startX = evt.clientX;
			multiscroll.startY = evt.clientY;
		
			this.active = true;
			this.done = true;
			
			this.insertMarker(evt);
			window.setCursor(this.cursor);
		},
		stop : function(evt) {
			this.active = false;
			this.removeMarker(evt);
			window.setCursor("default");
		},
		Do : function(evt) {
			window.setCursor(this.cursor);
			
			this.winMarker.style.left = this.winMarkerLeft + "px";
			this.winMarker.style.top = this.winMarkerTop + "px";
			
			if (this.settings.appearance == this.textured)
				for (var i = 0; i < 8; i++) {
					var el = this.docBackgroundMarker[i];
					el.style.left = 1 + ((i+2)%8<3 ? this.docMarkerLeft : this.winMarkerLeft + ((i+6)%8<3 ? this.winMarkerWidth : 0)) + "px";
					el.style.top = (i%8<3 ? this.docMarkerTop : this.winMarkerTop + ((i+4)%8<3 ? this.winMarkerHeight : 0)) + "px";
					el.style.width = ((i+2)%8<3 ? this.winMarkerLeft - this.docMarkerLeft : ((i+6)%8<3 ? this.docMarkerLeft + this.docMarkerWidth - this.winMarkerLeft - this.winMarkerWidth : this.winMarkerWidth)) + "px";
					el.style.height = (i%8<3 ? this.winMarkerTop - this.docMarkerTop : ((i+4)%8<3 ? this.docMarkerTop + this.docMarkerHeight - this.winMarkerTop - this.winMarkerHeight : this.winMarkerHeight)) + "px";
				}

			multiscroll.clientFrame.scrollTo(this.scrollX, this.scrollY);
		},
		createThumbnailInAdvance : function(evt) { with (multiscroll) {
			clientFrame = evt.originalTarget.ownerDocument.defaultView;
			clientFrameDoc = evt.originalTarget.ownerDocument;
			clientFrameBody = (clientFrameDoc.getElementsByTagName('body')[0])
							 ? clientFrameDoc.getElementsByTagName('body')[0]
							 : clientFrameDoc.getElementsByTagName('*')[0];
			clientWnd = evt.originalTarget.ownerDocument.contentWindow;
		
			if (clientFrameBody.nodeName == "window") return;
			if (clientFrameDoc.location == null) return;
		
			var docBox = clientFrameDoc.getBoxObjectFor(clientFrameDoc.documentElement);
		
			var pageXOffset = clientFrame.pageXOffset;
			var pageYOffset = clientFrame.pageYOffset;
		
			var documentWidth = docBox.width;
			var documentHeight = docBox.height;
		
			var windowWidth = Math.min(clientFrame.innerWidth, this.docWidth); // why are scrollbars included
			var windowHeight = Math.min(clientFrame.innerHeight, this.docHeight); // in window.innerWidth?
		
			this.scaleFactor = 1;
			this.scaleFactor = Math.min(this.scaleFactor, 
				windowWidth / (windowWidth / 2 + pageXOffset));
			this.scaleFactor = Math.min(this.scaleFactor, 
				(windowWidth - 20) / (documentWidth - windowWidth / 2 - pageXOffset));
			this.scaleFactor = Math.min(this.scaleFactor, 
				windowHeight / (windowHeight / 2 + pageYOffset));
			this.scaleFactor = Math.min(this.scaleFactor, 
				(windowHeight - 20) / (documentHeight - windowHeight / 2 - pageYOffset));
			this.scaleFactor = Math.min(this.scaleFactor,
				this.settings.size / Math.min(documentWidth, documentHeight));
		
			this.docBoxWidth = documentWidth * this.scaleFactor;
			this.docBoxHeight = documentHeight * this.scaleFactor;
		
			if (Math.abs(Math.log(this.oldScaleFactor/this.scaleFactor)) > 0.1
					 || this.docOldLocation != clientFrameDoc.location.href ) {
				var el = clientFrameDoc.createElementNS("http://www.w3.org/1999/xhtml", "div");
				el.style.overflow = "hidden";
				this.cloneElementToThumbnail(multiscroll.clientFrameBody, el, this.scaleFactor);
				el.style.position = "fixed";
				el.style.width = this.docMarkerWidth + "px";
				el.style.height = this.docMarkerHeight + "px";
				el.style.cursor = scrollCursor[PANNING];
				el.style.border = "2px solid gray";
		
				this.thumbnailMarker = el;
				this.oldScaleFactor = this.scaleFactor;
				this.docOldLocation = clientFrameDoc.location.href;
			}
		} },
		insertMarker : function(evt) { with (multiscroll) {
			var docBox = clientFrameDoc.getBoxObjectFor(clientFrameDoc.documentElement);
			var el;

			clientX = evt.clientX;
			clientY = evt.clientY;
			var pageXOffset = clientFrame.pageXOffset;
			var pageYOffset = clientFrame.pageYOffset;
			var documentWidth = docBox.width;
			var documentHeight = docBox.height;
			windowWidth = Math.min(clientFrame.innerWidth, documentWidth); // why are scrollbars included
			windowHeight = Math.min(clientFrame.innerHeight, documentHeight); // in window.innerWidth?
			
			// magic formula - do the maths if you don't trust it!
			this.scaleFactor = 1;
			this.scaleFactor = Math.min(this.scaleFactor, 
				clientX / (windowWidth / 2 + pageXOffset));
			this.scaleFactor = Math.min(this.scaleFactor, 
				(windowWidth - 20 - clientX) / (documentWidth - windowWidth / 2 - pageXOffset));
			this.scaleFactor = Math.min(this.scaleFactor, 
				clientY / (windowHeight / 2 + pageYOffset));
			this.scaleFactor = Math.min(this.scaleFactor, 
				(windowHeight - 20 - clientY) / (documentHeight - windowHeight / 2 - pageYOffset));
			this.scaleFactor = Math.min(this.scaleFactor,
				this.settings.size / Math.min(documentWidth, documentHeight));
		
			this.docMarkerWidth = documentWidth * this.scaleFactor;
			this.docMarkerHeight = documentHeight * this.scaleFactor;
			this.winMarkerWidth = windowWidth * this.scaleFactor;
			this.winMarkerHeight = windowHeight * this.scaleFactor;
	
			this.docMarkerLeft = clientX - this.winMarkerWidth / 2 - pageXOffset * this.scaleFactor;
			this.docMarkerTop = clientY - this.winMarkerHeight / 2 - pageYOffset * this.scaleFactor;
		
			// document box
			if (this.settings.appearance == this.thumbnail && Math.abs(Math.log(this.oldScaleFactor/this.scaleFactor)) < 0.1
					 && this.docOldLocation == multiscroll.clientFrameDoc.location.href ) {
				el = this.thumbnailMarker;
				el.style.left = this.docMarkerLeft + "px";
				el.style.top = this.docMarkerTop + "px";
				el.style.width = this.docMarkerWidth + "px";
				el.style.height = this.docMarkerHeight + "px";
			} else {
				el = clientFrameDoc.createElementNS("http://www.w3.org/1999/xhtml", "div");
				if (this.settings.appearance == this.textured) {
					el.style.backgroundImage = "url('" + this.image.docCorner + "')";
					el.style.backgroundPosition = "top right";
					el.style.backgroundRepeat = "no-repeat";
				} else if (this.settings.appearance == this.thumbnail) {
					el.style.overflow = "hidden";
					this.cloneElementToThumbnail(multiscroll.clientFrameBody, el, this.scaleFactor);
					this.thumbnailMarker = el;
					this.oldScaleFactor = this.scaleFactor;
					this.docOldLocation = clientFrameDoc.location.href;
				}
				el.style.position = "fixed";
				el.style.left = this.docMarkerLeft + "px";
				el.style.top = this.docMarkerTop + "px";
				el.style.width = this.docMarkerWidth + "px";
				el.style.height = this.docMarkerHeight + "px";
				el.style.cursor = this.cursor;
				el.style.border = "2px solid gray";
			}
			clientFrameBody.appendChild(el);
			this.docMarker = el;
		
			// window box
			if (this.settings.appearance == this.textured) {
				el = clientFrameDoc.createElementNS("http://www.w3.org/1999/xhtml", "img");
				el.src = this.image.screen;
			} else {
				el = clientFrameDoc.createElementNS("http://www.w3.org/1999/xhtml", "div");
			}
			el.style.position = "fixed";
			el.style.left = this.winMarkerLeft + "px";
			el.style.top = this.winMarkerTop + "px";
			el.style.width = this.winMarkerWidth + "px";
			el.style.height = this.winMarkerHeight + "px";
			el.style.cursor = this.cursor;
			el.style.border = "1px solid black";
		
			clientFrameBody.appendChild(el);
		
			this.winMarker = el;
		
			if (this.settings.appearance == this.textured) {
				this.docBackgroundMarker = [];
				for (var i = 0; i < 8; i++) {
					el = clientFrameDoc.createElementNS("http://www.w3.org/1999/xhtml", "div");
					el.style.position = "fixed";
					el.style.left = 1 + ((i+2)%8<3 ? this.docMarkerLeft : this.winMarkerLeft + ((i+6)%8<3 ? this.winMarkerWidth : 0)) + "px";
					el.style.top = (i%8<3 ? this.docMarkerTop : this.winMarkerTop + ((i+4)%8<3 ? this.winMarkerHeight : 0)) + "px";
					el.style.width = ((i+2)%8<3 ? this.winMarkerLeft - this.docMarkerLeft : ((i+6)%8<3 ? this.docMarkerLeft + this.docMarkerWidth - this.winMarkerLeft - this.winMarkerWidth : this.winMarkerWidth)) + "px";
					el.style.height = (i%8<3 ? this.winMarkerTop - this.docMarkerTop : ((i+4)%8<3 ? this.docMarkerTop + this.docMarkerHeight - this.winMarkerTop - this.winMarkerHeight : this.winMarkerHeight)) + "px";
					el.style.cursor = this.cursor;
					el.style.backgroundImage = "url('" + this.image.docBody + "')";
					clientFrameBody.appendChild(el);
					this.docBackgroundMarker[i] = el;
				}
			}
		} },
		removeMarker : function() {
			if (this.docMarker != null)
				this.docMarker.parentNode.removeChild(this.docMarker);
		
			if (this.winMarker != null)
				this.winMarker.parentNode.removeChild(this.winMarker);
		
			if (this.settings.appearance == this.textured)
				for (var i = 0; i < 8; i++)
					if (this.docBackgroundMarker != null)
				if (this.docBackgroundMarker[i] != null) {
					this.docBackgroundMarker[i].parentNode.removeChild(this.docBackgroundMarker[i]);
					this.docBackgroundMarker[i] = null;
				}
				
			this.docMarker = null;
			this.winMarker = null;
		
			if (this.settings.appearance == this.textured)
				this.docBackgroundMarker = null;
		},
		cloneElementToThumbnail : function(source, target, scale) {
			for (var i = 0; i < source.childNodes.length; i++) {
				target.appendChild(source.childNodes[i].cloneNode(true));
				scaleNodeRecursive(source.childNodes[i], target.childNodes[i], scale);
			}
			cs = clientFrame.getComputedStyle(source, '');
			scaleProperty(target, cs, 'fontSize', 'font-size', scale);
			scaleProperty(target, cs, 'letterSpacing', 'letter-spacing', scale);
			scaleProperty(target, cs, 'lineHeight', 'line-height', scale);
			scaleProperty(target, cs, 'wordSpacing', 'word-spacing', scale);
			copyProperty(target, cs, 'backgroundColor', 'background-color');
			copyProperty(target, cs, 'backgroundImage', 'background-image');
			copyProperty(target, cs, 'backgroundRepeat', 'background-repeat');
		},
		scaleNodeRecursive : function(original, node, scale) {
			if (node.nodeName == "SCRIPT" || node.nodeName == "HR") {
				node.parentNode.replaceChild(clientFrameDoc.createElementNS("http://www.w3.org/1999/xhtml", "script"), node);
			} else if (node.nodeType == 1) {multiscroll.
				scaleNode(original, node, scale);
				for (var i = 0; i < node.childNodes.length; i++) {
					if (node.childNodes[i].nodeType == 1)
				scaleNodeRecursive(original.childNodes[i], node.childNodes[i], scale);
				}
			}
		},
		arrScalableStyles : [
			'backgroundPosition', 'background-position',
			'borderSpacing', 'border-spacing',
			'borderTopWidth', 'border-top-width',
			'borderRightWidth', 'border-right-width',
			'borderBottomWidth', 'border-bottom-width',
			'borderLeftWidth', 'border-left-width',
			'bottom', 'bottom',
			'fontSize', 'font-size',
			'height', 'height',
			'left', 'left',
			'letterSpacing', 'letter-spacing',
			'lineHeight', 'line-height',
			'marginTop', 'margin-top',
			'marginRight', 'margin-right',
			'marginBottom', 'margin-bottom',
			'marginLeft', 'margin-left',
			'markerOffset', 'marker-offset',
			'maxHeight', 'max-height',
			'maxWidth', 'max-width',
			'minHeight', 'min-height',
			'minWidth', 'min-width',
			'outlineWidth', 'outline-width',
			'paddingTop', 'padding-top',
			'paddingRight', 'padding-right',
			'paddingBottom', 'padding-bottom',
			'paddingLeft', 'padding-left',
			'right', 'right',
			'size', 'size',
			'textIndent', 'text-indent',
			'textShadow', 'text-shadow',
			'top', 'top',
			'verticalAlign', 'vertical-align',
			'width', 'width',
			'wordSpacing', 'word-spacing'
		],
		scaleNode : function(original, node, scale) {
			cs = multiscroll.clientFrame.getComputedStyle(original, '');	// we use original because nodes do not acquire
			if (node.nodeName == "TABLE") {		// position properties till they are flowed in
				if (!isNaN(node.cellPadding)) node.cellPadding *= scale;
				if (!isNaN(node.cellSpacing)) node.cellSpacing *= scale;
				if (!isNaN(node.border)) node.border *= scale;
				node.style.padding = '0px';	// Believe it or not, when these are set as CSS rules on a table they fail to 
				node.style.margin = '0px';	// show up in computedStyle - we can't discover their values, all we can do is kill.
			}
			for ( var i = 0; i < this.arrScalableStyles.length; i += 2 )
				scaleProperty(node, cs, this.arrScalableStyles[i], this.arrScalableStyles[i+1], scale);
		},
		scaleProperty : function(node, cs, propertyCased, property_dashed, scale) {
			property = cs.getPropertyValue(property_dashed);
			if ( property == '0px' || property == '' || property.slice(-1) == '%' ) return;
			value = (property == 'thin') ? 1 : (property == 'medium') ? 3 : (property == 'thick') ? 5 : Number(property.slice(0, -2));
			if ( value == 0 || isNaN(value) ) return;
			eval( "node.style." + propertyCased + "='" + value * scale + "px';" );
		},
		copyProperty : function(node, cs, propertyCased, property_dashed) {
			eval( "node.style." + propertyCased + "='" + cs.getPropertyValue(property_dashed) + "';" );
		}
	}
});
