function MultiscrollPrefsObserver() {
	try {
		var mprefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
		mprefs.QueryInterface(Components.interfaces.nsIPrefBranchInternal).addObserver(this.domain, this, false);
	} catch (ex) {
		;
	}
}

MultiscrollPrefsObserver.prototype = {
	prefs : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("multiscroll."),
	domain : "multiscroll",
	
	// handle changes in settings
	observe : function(subject, topic, pname) {
		try {
			if (pname.split('.')[0] != this.domain) return;
			switch (pname.split('.')[1]) {
				case "activateShiftOn":
					multiscroll.activate.shift = this.prefs.getBoolPref("activateShiftOn");
					break;
				case "activateCtrlOn":
					multiscroll.activate.ctrl = this.prefs.getBoolPref("activateCtrlOn");
					break;
				case "activateAltOn":
					multiscroll.activate.alt = this.prefs.getBoolPref("activateAltOn");
					break;
				case "activateMetaOn":
					multiscroll.activate.meta = this.prefs.getBoolPref("activateMetaOn");
					break;
				case "activateButton":
					multiscroll.activate.button = this.prefs.getIntPref("activateButton");
					break;
				case "activateAction":
					multiscroll.activate.action = this.prefs.getIntPref("activateAction");
					break;
				case "cancelKey":
					multiscroll.cancelKey = this.prefs.getIntPref("cancelKey");
					break;
				case "exitAction":
					multiscroll.exitAction = this.prefs.getIntPref("exitAction");
					break;
				case "actionTool":
					multiscroll.action[pname.split('.')[2]].tool = multiscroll.tool.byCode(this.prefs.getIntPref("actionTool." + pname.split('.')[2]));
					break;
				case "actionMultiplier":
					multiscroll.action[pname.split('.')[2]].settings.multiplier = parseFloat(this.prefs.getCharPref("actionMultiplier." + pname.split('.')[2]));
					break;
				case "actionExponent":
					multiscroll.action[pname.split('.')[2]].settings.exponent = parseFloat(this.prefs.getCharPref("actionExponent." + pname.split('.')[2]));
					break;
				case "actionSize":
					multiscroll.action[pname.split('.')[2]].settings.size = this.prefs.getIntPref("actionSize." + pname.split('.')[2]);
					break;
				case "actionAppearance":
					multiscroll.action[pname.split('.')[2]].settings.appearance = this.prefs.getIntPref("actionAppearance." + pname.split('.')[2]);
					break;
			}
		} catch (ex) {
			;
		}
	}
}

multiscroll.preferences = {};
multiscroll.preferences.load = function() {
	var index;
	try {
		multiscroll.activate.shift = multiscroll.prefsObserver.prefs.getBoolPref("activateShiftOn");
		multiscroll.activate.ctrl = multiscroll.prefsObserver.prefs.getBoolPref("activateCtrlOn");
		multiscroll.activate.alt = multiscroll.prefsObserver.prefs.getBoolPref("activateAltOn");
		multiscroll.activate.meta = multiscroll.prefsObserver.prefs.getBoolPref("activateMetaOn");
		multiscroll.activate.button = multiscroll.prefsObserver.prefs.getIntPref("activateButton");
		multiscroll.activate.action = multiscroll.prefsObserver.prefs.getIntPref("activateAction");
		multiscroll.cancelKey = multiscroll.prefsObserver.prefs.getIntPref("cancelKey");
		multiscroll.exitAction = multiscroll.prefsObserver.prefs.getIntPref("exitAction");
		for (index in multiscroll.action) {
			multiscroll.action[index].tool = multiscroll.tool.byCode(multiscroll.prefsObserver.prefs.getIntPref("actionTool." + index));
			multiscroll.action[index].settings.multiplier = parseFloat(multiscroll.prefsObserver.prefs.getCharPref("actionMultiplier." + index));
			multiscroll.action[index].settings.exponent = parseFloat(multiscroll.prefsObserver.prefs.getCharPref("actionExponent." + index));
			multiscroll.action[index].settings.size = multiscroll.prefsObserver.prefs.getIntPref("actionSize." + index);
			multiscroll.action[index].settings.appearance = multiscroll.prefsObserver.prefs.getIntPref("actionAppearance." + index);
		}
	} catch(ex) {
		multiscroll.prefsObserver.prefs.setBoolPref("activateShiftOn", multiscroll.activate.shift);
		multiscroll.prefsObserver.prefs.setBoolPref("activateCtrlOn", multiscroll.activate.ctrl);
		multiscroll.prefsObserver.prefs.setBoolPref("activateAltOn", multiscroll.activate.alt);
		multiscroll.prefsObserver.prefs.setBoolPref("activateMetaOn", multiscroll.activate.meta);
		multiscroll.prefsObserver.prefs.setIntPref("activateButton", multiscroll.activate.button);
		multiscroll.prefsObserver.prefs.setIntPref("activateAction", multiscroll.activate.action);
		multiscroll.prefsObserver.prefs.setIntPref("cancelKey", multiscroll.cancelKey);
		multiscroll.prefsObserver.prefs.setIntPref("exitAction", multiscroll.exitAction);
		for (index in multiscroll.action) {
			multiscroll.prefsObserver.prefs.setIntPref("actionTool." + index, multiscroll.tool.code(multiscroll.action[index].tool));
			multiscroll.prefsObserver.prefs.setCharPref("actionMultiplier." + index, String(multiscroll.action[index].settings.multiplier));
			multiscroll.prefsObserver.prefs.setCharPref("actionExponent." + index, String(multiscroll.action[index].settings.exponent));
			multiscroll.prefsObserver.prefs.setIntPref("actionSize." + index, multiscroll.action[index].settings.size);
			multiscroll.prefsObserver.prefs.setIntPref("actionAppearance." + index, multiscroll.action[index].settings.appearance);
		}
	}
};

multiscroll.prefsObserver = new MultiscrollPrefsObserver();
window.addEventListener("load", multiscroll.preferences.load, true);
