mergeObjects(multiscroll, {
	scroll : {
		count : 0,
		scrollX : 0,
		scrollY : 0,
		markerImage : null,
		overlayContainer : null,
		all : {
			get image() { return multiscroll.scroll.image.all; },
			get cursor() { return multiscroll.scroll.cursor.all; },
		},
		vertical : {
			get image() { return multiscroll.scroll.image.vertical; },
			get cursor() { return multiscroll.scroll.cursor.vertical; },
		},
		horizontal : {
			get image() { return multiscroll.scroll.image.horizontal; },
			get cursor() { return multiscroll.scroll.cursor.horizontal; },
		}
	}
});
multiscroll.scroll.type getter= function() {
			return multiscroll.windowHeight < multiscroll.documentHeight && multiscroll.windowWidth >= multiscroll.documentWidth ? multiscroll.scroll.vertical
				: multiscroll.windowHeight >= multiscroll.documentHeight && multiscroll.windowWidth < multiscroll.documentWidth ? multiscroll.scroll.horizontal
				: multiscroll.scroll.all;
		};
mergeObjects(multiscroll, {
	scroll : {
		start : function(evt) { with (multiscroll) {
			startX = evt.clientX;
			startY = evt.clientY;
		
			scroll.active = true;
			scroll.done = true;
			
			scroll.scrollX = clientFrame.pageXOffset;
			scroll.scrollY = clientFrame.pageYOffset;

			clientX = evt.clientX;
			clientY = evt.clientY;
			browserClientX = evt.screenX - window.screenX - clientX;
			browserClientY = evt.screenY - window.screenY - clientY;

			scroll.insertMarker(evt);
		
			setTimeout(scroll.loop, 5);
		} },
		stop : function(evt) { with (multiscroll) {
			scroll.active = false;
			scroll.removeMarker(evt);
		} },
		loop : function() { with (multiscroll) {
			if (scroll.active) {
				var x = (clientX - startX) * scroll.settings.multiplier;
				var y = (clientY - startY) * scroll.settings.multiplier;
				x = x>0 ? Math.pow(Math.abs(x), scroll.settings.exponent) : x<0 ? -Math.pow(Math.abs(x), scroll.settings.exponent) : 0;
				y = y>0 ? Math.pow(Math.abs(y), scroll.settings.exponent) : y<0 ? -Math.pow(Math.abs(y), scroll.settings.exponent) : 0;
		
				if (Math.abs(x) > 0 && Math.abs(y) > 0) {	// I do not expect to understand this
					if (scroll.count++ % 2)
						y = 0;
					else
						x = 0;
				}
				scroll.scrollX += x;
				scroll.scrollY += y;
				clientFrame.scrollTo(scroll.scrollX, scroll.scrollY);
				if (Math.abs(scroll.scrollX - clientFrame.pageXOffset) > 10 )
					scroll.scrollX = clientFrame.pageXOffset;
				if (Math.abs(scroll.scrollY - clientFrame.pageYOffset) > 10 )
					scroll.scrollY = clientFrame.pageYOffset;
				// retain sub-pixel movements but protect edges from exponential dragging
				setTimeout(scroll.loop, 5);
			}
		} },
		//	The following submitted by: Erik Arvidsson erik@eae.net 
		//	Slightly modified by: Matthew Ratzloff matt@kanchi.org
		//	http://www.mozdev.org/pipermail/autoscroll/2002-December/000002.html
		insertMarker : function(evt) {
			var docBox = multiscroll.clientFrameDoc.getBoxObjectFor(multiscroll.clientFrameDoc.documentElement);
			var left = evt.screenX - docBox.screenX;
			var top = evt.screenY - docBox.screenY;
			
			multiscroll.documentWidth = docBox.width;
			multiscroll.documentHeight = docBox.height;
			multiscroll.windowWidth = window.innerWidth;
			multiscroll.windowHeight = window.innerHeight;
			var imageWidth = 28;
			var imageHeight = 28;
		
			// overlay
			var el = multiscroll.clientFrameDoc.createElementNS("http://www.w3.org/1999/xhtml", "div");
			el.style.position = "fixed";
			el.style.left = "0px";
			el.style.top = "0px";
			el.style.width = multiscroll.documentWidth + "px";
			el.style.height = multiscroll.documentHeight + "px";
			el.style.cursor = this.type.cursor;
		
			multiscroll.clientFrameBody.appendChild(el);
			this.overlayContainer = el;
		
			// marker
			el = multiscroll.clientFrameDoc.createElementNS("http://www.w3.org/1999/xhtml", "img");
			el.src = this.type.image;
		
			el.style.position = "fixed";
			el.style.left = left - imageWidth / 2 + "px";
			el.style.top = top - imageHeight / 2 + "px";
			el.style.width = imageWidth + "px";
			el.style.height = imageHeight + "px";
			el.style.cursor = this.type.cursor;
		
			multiscroll.clientFrameBody.appendChild(el);
		
			this.markerImage = el;
		},
		removeMarker : function() {
			if (this.markerImage != null)
				this.markerImage.parentNode.removeChild(this.markerImage);
		
			if (this.overlayContainer != null)
				this.overlayContainer.parentNode.removeChild(this.overlayContainer);
			
			this.overlayContainer = null;
			this.markerImage = null;
		}
	}
});